diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/EntityCategory.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/EntityCategory.java
new file mode 100644
index 000000000..ef8f5e3a6
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/EntityCategory.java
@@ -0,0 +1,203 @@
+package net.minecraft.client.gui.modelviewer.categories;
+
+import net.minecraft.client.gui.GuiButton;
+import net.minecraft.client.gui.modelviewer.GuiModelViewer;
+import net.minecraft.client.gui.modelviewer.categories.entries.entity.DispatcherEntry;
+import net.minecraft.client.gui.modelviewer.categories.entries.entity.EntityArmoredZombieEntry;
+import net.minecraft.client.gui.modelviewer.categories.entries.entity.EntityBoatEntry;
+import net.minecraft.client.gui.modelviewer.categories.entries.entity.EntityCreeperEntry;
+import net.minecraft.client.gui.modelviewer.categories.entries.entity.EntityEntry;
+import net.minecraft.client.gui.modelviewer.categories.entries.entity.EntityFallingSandEntry;
+import net.minecraft.client.gui.modelviewer.categories.entries.entity.EntityFireflyEntry;
+import net.minecraft.client.gui.modelviewer.categories.entries.entity.EntityItemEntry;
+import net.minecraft.client.gui.modelviewer.categories.entries.entity.EntityMinecartEntry;
+import net.minecraft.client.gui.modelviewer.categories.entries.entity.EntityPaintingEntry;
+import net.minecraft.client.gui.modelviewer.categories.entries.entity.EntitySheepEntry;
+import net.minecraft.client.gui.modelviewer.categories.entries.entity.EntitySlimeEntry;
+import net.minecraft.client.gui.modelviewer.categories.entries.entity.EntityTNTEntry;
+import net.minecraft.client.gui.modelviewer.categories.entries.entity.EntityWolfEntry;
+import net.minecraft.client.gui.modelviewer.elements.GuiListenerTextField;
+import net.minecraft.client.gui.modelviewer.elements.GuiTextCycle;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.EntityDispatcher;
+import net.minecraft.core.entity.EntityLiving;
+import net.minecraft.core.entity.monster.EntityHuman;
+import net.minecraft.core.entity.monster.EntityZombie;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.util.helper.MathHelper;
+
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.List;
+
+public class EntityCategory extends ModelViewerCategory{
+    public HashMap<Class<? extends Entity>, EntityEntry<?>> entryMap = new HashMap<>();
+    public List<EntityEntry<?>> entryList = new ArrayList<>();
+    public GuiListenerTextField entityName;
+    public GuiTextCycle<Integer> entityVariant;
+    public EntityEntry<?> currentEntry = EntityEntry.blankEntry;
+    public Entity displayEntity;
+    public EntityCategory(GuiModelViewer modelViewer) {
+        super(modelViewer);
+        createEntries();
+    }
+    public void createEntries(){
+        for (String s : EntityDispatcher.classToKeyMap.values()){
+            try{
+                addEntry(new DispatcherEntry(s));
+            } catch (Exception ignore){}
+        }
+        addEntry(new EntityItemEntry());
+        addEntry(new EntityFireflyEntry());
+        addEntry(new EntitySheepEntry());
+        addEntry(new EntityWolfEntry());
+        addEntry(new EntityCreeperEntry());
+        addEntry(new EntityArmoredZombieEntry());
+        addEntry(new EntitySlimeEntry());
+        addEntry(new EntityMinecartEntry());
+        addEntry(new EntityBoatEntry());
+        addEntry(new EntityFallingSandEntry());
+        addEntry(new EntityTNTEntry());
+        addEntry(new EntityPaintingEntry());
+    }
+    public void addEntry(EntityEntry<?> entry){
+        Entity entity = entry.getEntityInstance(mc, mc.theWorld);
+        if (entity == null) return;
+        EntityEntry<?> oldEntry = entryMap.put(entity.getClass(), entry);
+        entryList.remove(oldEntry);
+        entryList.add(entry);
+    }
+    @SuppressWarnings("unchecked")
+    public <V extends Entity> EntityEntry<V> getEntry(V entity){
+        return (EntityEntry<V>) entryMap.getOrDefault(entity.getClass(), EntityEntry.blankEntry);
+    }
+
+    @Override
+    public String getCategoryNameKey() {
+        return "model.category.entity.name";
+    }
+
+    @Override
+    public String getCurrentDisplayInfo(I18n translator) {
+        String title = "None";
+        if (displayEntity != null){
+            title = Entity.getNameFromEntity(displayEntity, false);
+        }
+        return translator.translateKeyAndFormat("model.category.entity.info", title);
+    }
+
+    @Override
+    public void addContextButtons(List<GuiButton> buttonList) {
+        GuiButton lastButton = buttonList.get(buttonList.size()-1);
+        boolean isLiving = displayEntity instanceof EntityLiving;
+        if (isLiving){
+            entityVariant = new GuiTextCycle<Integer>(modelViewer, mc.fontRenderer, modelViewer.width - 120, lastButton.yPosition + 21, 120, 20, 0) {
+                @Override
+                public Integer cycleElement(Integer current, int offset) {
+                    return (current + offset) & 0x7F;
+                }
+
+                @Override
+                public Integer getElementFromString(String s) {
+                    try {
+                        int id = Integer.parseInt(s);
+                        return MathHelper.clamp(id, 0, Byte.MAX_VALUE);
+                    } catch (Exception ignored){}
+                    return (int) displayEntity.getEntityData().getByte(1);
+                }
+
+                @Override
+                public String getNameFromElement(Integer element) {
+                    return String.valueOf(element);
+                }
+            };
+            entityVariant.setOnValueChanged(() -> ((EntityLiving) displayEntity).setSkinVariant(entityVariant.getCurrentElement()));
+            entityVariant.textField.setPlaceholder("Variant");
+            entityVariant.textField.setPrefaceText("Variant: ");
+            buttonList.add(entityVariant);
+
+            entityName = new GuiListenerTextField(modelViewer, mc.fontRenderer, modelViewer.width - 120, entityVariant.yPosition + 21, 120, 20, "", "Nickname");
+            entityName.setTextChangeListener(modelViewer);
+            buttonList.add(entityName);
+        }
+
+        lastButton = buttonList.get(buttonList.size()-1);
+        int xPos = modelViewer.width;
+        int yPos = lastButton.getY() + lastButton.getHeight() + 1;
+
+        List<GuiButton> entryButtons = getEntry(displayEntity).getEntryButtons(mc, modelViewer, displayEntity);
+        if (entryButtons != null){
+            for (GuiButton button : entryButtons) {
+                button.setX(button.getX() + xPos);
+                button.setY(button.getY() + yPos);
+            }
+            buttonList.addAll(entryButtons);
+        }
+    }
+
+    @Override
+    public void cycleCategoryEntry(int offset) {
+        int id = 0;
+        List<EntityEntry<?>> _val = new ArrayList<>(entryList);
+        if (currentEntry != EntityEntry.blankEntry){
+            id = _val.indexOf(currentEntry);
+        }
+        currentEntry.onClose();
+        currentEntry = _val.get((id + _val.size() + offset) % _val.size());
+        currentEntry.onOpen();
+
+        setDisplayEntity(currentEntry.getEntityInstance(mc, mc.theWorld));
+    }
+
+    @Override
+    public void onOpen() {
+        currentEntry = entryMap.get(EntityZombie.class);
+        currentEntry.onOpen();
+        setDisplayEntity(currentEntry.getEntityInstance(mc, mc.theWorld));
+    }
+
+    @Override
+    public void onClose() {
+        currentEntry.onClose();
+        removeDisplayEntity();
+    }
+
+    @Override
+    public void onTick(){
+        if (displayEntity != null){
+            displayEntity.tickCount++;
+            getEntry(displayEntity).onTick(displayEntity);
+        }
+        if (!(displayEntity instanceof EntityHuman) || System.currentTimeMillis() > modelViewer.timeLastKeyPressed + 1000){
+            if (displayEntity != null && displayEntity instanceof EntityLiving){
+                String oldNick = ((EntityLiving) displayEntity).nickname;
+                if (!oldNick.equals(entityName.getText())){
+                    ((EntityLiving) displayEntity).setNickname(entityName.getText());
+                }
+            }
+        }
+    }
+    public void setDisplayEntity(Entity entity){
+        removeDisplayEntity();
+        displayEntity = entity;
+        if (displayEntity != null){
+            displayEntity.noPhysics = true;
+
+            displayEntity.absMoveTo(mc.thePlayer.x, mc.thePlayer.y - displayEntity.bbHeight/2, mc.thePlayer.z, displayEntity.yRot, displayEntity.xRot);
+            displayEntity.lerpMotion(0, 0, 0);
+            mc.theWorld.entityJoinedWorld(displayEntity);
+            if (displayEntity instanceof EntityLiving){
+                ((EntityLiving) displayEntity).setSkinVariant(0);
+            }
+        }
+        mc.effectRenderer.clearEffects(mc.theWorld);
+        modelViewer.init();
+    }
+    public void removeDisplayEntity(){
+        if (displayEntity != null){
+            displayEntity.remove();
+            mc.theWorld.loadedEntityList.remove(displayEntity);
+        }
+        mc.effectRenderer.clearEffects(mc.theWorld);
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/ModelViewerCategory.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/ModelViewerCategory.java
new file mode 100644
index 000000000..821e75e33
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/ModelViewerCategory.java
@@ -0,0 +1,24 @@
+package net.minecraft.client.gui.modelviewer.categories;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.GuiButton;
+import net.minecraft.client.gui.modelviewer.GuiModelViewer;
+import net.minecraft.core.lang.I18n;
+
+import java.util.List;
+
+public abstract class ModelViewerCategory {
+    protected final GuiModelViewer modelViewer;
+    protected final Minecraft mc;
+    public ModelViewerCategory(GuiModelViewer modelViewer){
+        this.modelViewer = modelViewer;
+        this.mc = Minecraft.getMinecraft(this);
+    }
+    public abstract String getCategoryNameKey();
+    public abstract String getCurrentDisplayInfo(I18n translator);
+    public abstract void addContextButtons(List<GuiButton> buttonList);
+    public abstract void cycleCategoryEntry(int offset);
+    public abstract void onOpen();
+    public abstract void onClose();
+    public abstract void onTick();
+}
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/ParticleCategory.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/ParticleCategory.java
new file mode 100644
index 000000000..a015ecdc8
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/ParticleCategory.java
@@ -0,0 +1,132 @@
+package net.minecraft.client.gui.modelviewer.categories;
+
+import net.minecraft.client.gui.GuiButton;
+import net.minecraft.client.gui.modelviewer.GuiModelViewer;
+import net.minecraft.client.gui.modelviewer.categories.entries.particle.BlockFXEntry;
+import net.minecraft.client.gui.modelviewer.categories.entries.particle.BubbleFXEntry;
+import net.minecraft.client.gui.modelviewer.categories.entries.particle.GenericFXEntry;
+import net.minecraft.client.gui.modelviewer.categories.entries.particle.ItemFXEntry;
+import net.minecraft.client.gui.modelviewer.categories.entries.particle.LeafFXEntry;
+import net.minecraft.client.gui.modelviewer.categories.entries.particle.NoteFXEntry;
+import net.minecraft.client.gui.modelviewer.categories.entries.particle.ParticleEntry;
+import net.minecraft.client.gui.modelviewer.categories.entries.particle.RedDustFXEntry;
+import net.minecraft.client.gui.modelviewer.elements.GuiListenerSlider;
+import net.minecraft.core.lang.I18n;
+
+import java.util.ArrayList;
+import java.util.List;
+
+public class ParticleCategory extends ModelViewerCategory{
+    public List<ParticleEntry> entries = new ArrayList<>();
+    public double spawnRadius = 0;
+    public ParticleEntry currentEntry;
+
+    public ParticleCategory(GuiModelViewer modelViewer) {
+        super(modelViewer);
+        initEntries();
+    }
+    private void initEntries(){
+        entries.add(new BubbleFXEntry());
+        entries.add(new GenericFXEntry("smoke"));
+        entries.add(new NoteFXEntry());
+        entries.add(new GenericFXEntry("portal"));
+        entries.add(new GenericFXEntry("explode"));
+        entries.add(new GenericFXEntry("flame"));
+        entries.add(new GenericFXEntry("blueflame"));
+        entries.add(new GenericFXEntry("soulflame"));
+        entries.add(new GenericFXEntry("lava"));
+        entries.add(new GenericFXEntry("footstep"));
+        entries.add(new GenericFXEntry("splash"));
+        entries.add(new GenericFXEntry("largesmoke"));
+        entries.add(new RedDustFXEntry());
+        entries.add(new ItemFXEntry());
+        entries.add(new BlockFXEntry());
+        entries.add(new GenericFXEntry("snowshovel"));
+        entries.add(new GenericFXEntry("heart"));
+        entries.add(new GenericFXEntry("slimechunk"));
+        entries.add(new GenericFXEntry("fireflyGreen"));
+        entries.add(new GenericFXEntry("fireflyBlue"));
+        entries.add(new GenericFXEntry("fireflyOrange"));
+        entries.add(new GenericFXEntry("fireflyRed"));
+        entries.add(new GenericFXEntry("arrowtrail"));
+        entries.add(new LeafFXEntry());
+        entries.add(new GenericFXEntry("boatbreak"));
+    }
+    private void setCurrentEntry(ParticleEntry entry){
+        if (currentEntry != null){
+            currentEntry.onClose();
+        }
+        currentEntry = entry;
+        if (currentEntry != null){
+            currentEntry.onOpen();
+        }
+    }
+
+    @Override
+    public String getCategoryNameKey() {
+        return "model.category.particle.name";
+    }
+
+    @Override
+    public String getCurrentDisplayInfo(I18n translator) {
+        return translator.translateKeyAndFormat("model.category.particle.info", currentEntry.getParticleName(translator));
+    }
+
+    @Override
+    public void addContextButtons(List<GuiButton> buttonList) {
+        GuiButton lastButton = buttonList.get(buttonList.size()-1);
+        GuiListenerSlider radiusSlider = new GuiListenerSlider(-1, modelViewer.width - 120, lastButton.yPosition + 21, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.particle.radius.slider", ((int)(spawnRadius * 100))/100f), (float) spawnRadius);
+        radiusSlider.setOnValueChanged(() ->{
+            spawnRadius = radiusSlider.sliderValue;
+            radiusSlider.displayString = I18n.getInstance().translateKeyAndFormat("model.category.particle.radius.slider", ((int)(spawnRadius * 100))/100f);
+        });
+        buttonList.add(radiusSlider);
+
+        int xPos = modelViewer.width;
+        int yPos = radiusSlider.getY() + radiusSlider.getHeight() + 1;
+
+        List<GuiButton> buttons = currentEntry.getEntryButtons(mc, modelViewer);
+        if (buttons != null){
+            for (GuiButton button: buttons){
+                button.setX(button.getX() + xPos);
+                button.setY(button.getY() + yPos);
+            }
+            buttonList.addAll(buttons);
+        }
+    }
+
+    @Override
+    public void cycleCategoryEntry(int offset) {
+        setCurrentEntry(entries.get((entries.indexOf(currentEntry) + entries.size() + offset) % entries.size()));
+        mc.effectRenderer.clearEffects(mc.theWorld);
+        modelViewer.init();
+    }
+
+    @Override
+    public void onOpen() {
+        spawnRadius = 0;
+        setCurrentEntry(entries.get(0));
+    }
+
+    @Override
+    public void onClose() {
+        mc.effectRenderer.clearEffects(mc.theWorld);
+        currentEntry.onClose();
+    }
+
+    @Override
+    public void onTick() {
+        double offX = 0;
+        double offY = 0;
+        double offZ = 0;
+        if (spawnRadius > 0){
+            offX = mc.theWorld.rand.nextDouble() - mc.theWorld.rand.nextDouble();
+            offY = mc.theWorld.rand.nextDouble() - mc.theWorld.rand.nextDouble();
+            offZ = mc.theWorld.rand.nextDouble() - mc.theWorld.rand.nextDouble();
+        }
+        offX *= spawnRadius;
+        offY *= spawnRadius;
+        offZ *= spawnRadius;
+        currentEntry.spawnParticle(mc, mc.theWorld, mc.thePlayer.x + offX, mc.thePlayer.y + offY, mc.thePlayer.z + offZ);
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BasicBlockEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BasicBlockEntry.java
new file mode 100644
index 000000000..ec6d09414
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BasicBlockEntry.java
@@ -0,0 +1,35 @@
+package net.minecraft.client.gui.modelviewer.categories.entries.block;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.GuiButton;
+import net.minecraft.client.gui.GuiScreen;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.world.World;
+
+import java.util.List;
+
+public class BasicBlockEntry extends BlockEntry{
+    public BasicBlockEntry(Block block) {
+        super(block);
+    }
+
+    @Override
+    public void onTick(World world, int meta) {
+
+    }
+
+    @Override
+    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, World world, int meta) {
+        return null;
+    }
+
+    @Override
+    public void onClose(World world, int meta) {
+
+    }
+
+    @Override
+    public void onOpen(World world, int meta) {
+
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BlockEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BlockEntry.java
new file mode 100644
index 000000000..5725909fc
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BlockEntry.java
@@ -0,0 +1,21 @@
+package net.minecraft.client.gui.modelviewer.categories.entries.block;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.GuiButton;
+import net.minecraft.client.gui.GuiScreen;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.world.World;
+
+import java.util.List;
+
+public abstract class BlockEntry {
+    public Block block;
+    public BlockEntry(Block block){
+        this.block = block;
+    }
+
+    public abstract void onTick(World world, int meta);
+    public abstract List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, World world, int meta);
+    public abstract void onClose(World world, int meta);
+    public abstract void onOpen(World world, int meta);
+}
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/JarEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/JarEntry.java
new file mode 100644
index 000000000..7fa0c24ed
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/JarEntry.java
@@ -0,0 +1,67 @@
+package net.minecraft.client.gui.modelviewer.categories.entries.block;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.GuiButton;
+import net.minecraft.client.gui.GuiScreen;
+import net.minecraft.client.gui.modelviewer.GuiModelViewer;
+import net.minecraft.client.gui.modelviewer.elements.GuiTextCycle;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.entity.TileEntityFlowerJar;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.chunk.DisplayChunk;
+
+import java.util.ArrayList;
+import java.util.List;
+
+public class JarEntry extends BlockEntry{
+    public JarEntry() {
+        super(Block.jarGlass);
+    }
+
+    @Override
+    public void onTick(World world, int meta) {
+
+    }
+
+    @Override
+    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, World world, int meta) {
+        GuiTextCycle<Integer> jarCycle = new GuiTextCycle<Integer>(parentScreen, mc.fontRenderer, - 120, 0, 120, 20, 0) {
+            @Override
+            public Integer cycleElement(Integer current, int offset) {
+                return GuiModelViewer.cycleBlockId(current, offset);
+            }
+
+            @Override
+            public Integer getElementFromString(String s) {
+                try {
+                    int id = MathHelper.clamp(Integer.parseInt(s), 0, Block.blocksList.length);
+                    if (Block.getBlock(id) != null){
+                        return id;
+                    }
+                } catch (Exception ignored){}
+                return DisplayChunk.displayBlockId;
+            }
+
+            @Override
+            public String getNameFromElement(Integer element) {
+                return String.valueOf(element);
+            }
+        };
+        jarCycle.textField.setPrefaceText("Jar: ");
+        jarCycle.textField.setPlaceholder("Jar ID");
+        jarCycle.setOnValueChanged(() -> ((TileEntityFlowerJar)DisplayChunk.displayTileEntity).flowerInPot = jarCycle.getCurrentElement());
+
+        return new ArrayList<GuiButton>(){{add(jarCycle);}};
+    }
+
+    @Override
+    public void onClose(World world, int meta) {
+
+    }
+
+    @Override
+    public void onOpen(World world, int meta) {
+
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/MobSpawnerEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/MobSpawnerEntry.java
new file mode 100644
index 000000000..6a884f8e8
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/MobSpawnerEntry.java
@@ -0,0 +1,61 @@
+package net.minecraft.client.gui.modelviewer.categories.entries.block;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.GuiButton;
+import net.minecraft.client.gui.GuiScreen;
+import net.minecraft.client.gui.modelviewer.elements.GuiListSelectorButton;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.entity.TileEntityMobSpawner;
+import net.minecraft.core.entity.EntityDispatcher;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.chunk.DisplayChunk;
+
+import java.util.ArrayList;
+import java.util.List;
+
+public class MobSpawnerEntry extends BlockEntry{
+    public MobSpawnerEntry() {
+        super(Block.mobspawner);
+    }
+
+    @Override
+    public void onTick(World world, int meta) {
+        TileEntityMobSpawner spawner = (TileEntityMobSpawner) DisplayChunk.displayTileEntity;
+        spawner.yaw2 = spawner.yaw;
+        double xPos = (double) spawner.x + spawner.worldObj.rand.nextFloat();
+        double yPos = (double) spawner.y + spawner.worldObj.rand.nextFloat();
+        double zPos = (double) spawner.z + spawner.worldObj.rand.nextFloat();
+        spawner.worldObj.spawnParticle("smoke", xPos, yPos, zPos, 0.0D, 0.0D, 0.0D);
+        spawner.worldObj.spawnParticle("flame", xPos, yPos, zPos, 0.0D, 0.0D, 0.0D);
+        for(spawner.yaw += 1000F / ((float)spawner.delay + 200F); spawner.yaw > 360D;)
+        {
+            spawner.yaw -= 360D;
+            spawner.yaw2 -= 360D;
+        }
+    }
+
+    @Override
+    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, World world, int meta) {
+        List<String> ids = new ArrayList<>(EntityDispatcher.keyToClassMap.keySet());
+        ids.remove("mob");
+        GuiListSelectorButton<String> dispatcherIds = new GuiListSelectorButton<String>(-1, -120, 0, 120, 20, I18n.getInstance().translateKey("model.category.block.spawner.button.id"), ids, "Pig") {
+            @Override
+            public String getNameFromElement(String element) {
+                return element;
+            }
+        };
+        dispatcherIds.setOnValueChanged(() -> ((TileEntityMobSpawner)DisplayChunk.displayTileEntity).setMobId(dispatcherIds.getCurrentElement()));
+        return new ArrayList<GuiButton>(){{add(dispatcherIds);}};
+    }
+
+    @Override
+    public void onClose(World world, int meta) {
+
+    }
+
+    @Override
+    public void onOpen(World world, int meta) {
+
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/SignEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/SignEntry.java
new file mode 100644
index 000000000..af1fba73a
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/SignEntry.java
@@ -0,0 +1,54 @@
+package net.minecraft.client.gui.modelviewer.categories.entries.block;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.GuiButton;
+import net.minecraft.client.gui.GuiScreen;
+import net.minecraft.client.gui.modelviewer.elements.GuiListenerTextField;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.entity.TileEntitySign;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.chunk.DisplayChunk;
+
+import java.util.ArrayList;
+import java.util.List;
+
+public class SignEntry extends BlockEntry{
+    public SignEntry(Block block) {
+        super(block);
+    }
+
+    @Override
+    public void onTick(World world, int meta) {
+
+    }
+
+    @Override
+    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, World world, int meta) {
+        TileEntitySign sign = (TileEntitySign)DisplayChunk.displayTileEntity;
+        GuiListenerTextField line1 = new GuiListenerTextField(parentScreen, mc.fontRenderer, -120, 0,                       120, 20, "", "Line 1");
+        GuiListenerTextField line2 = new GuiListenerTextField(parentScreen, mc.fontRenderer, -120, line1.yPosition + 21,    120, 20, "", "Line 2");
+        GuiListenerTextField line3 = new GuiListenerTextField(parentScreen, mc.fontRenderer, -120, line2.yPosition + 21,    120, 20, "", "Line 3");
+        GuiListenerTextField line4 = new GuiListenerTextField(parentScreen, mc.fontRenderer, -120, line3.yPosition + 21,    120, 20, "", "Line 4");
+        line1.setOnValueChanged(() -> sign.signText[0] = line1.getText());
+        line2.setOnValueChanged(() -> sign.signText[1] = line2.getText());
+        line3.setOnValueChanged(() -> sign.signText[2] = line3.getText());
+        line4.setOnValueChanged(() -> sign.signText[3] = line4.getText());
+        return new ArrayList<GuiButton>(){
+            {
+                add(line1);
+                add(line2);
+                add(line3);
+                add(line4);
+            }};
+    }
+
+    @Override
+    public void onClose(World world, int meta) {
+        DisplayChunk.setDisplayTileEntity(world, null);
+    }
+
+    @Override
+    public void onOpen(World world, int meta) {
+        DisplayChunk.setDisplayTileEntity(world, new TileEntitySign());
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/BlankEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/BlankEntry.java
new file mode 100644
index 000000000..9766af221
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/BlankEntry.java
@@ -0,0 +1,36 @@
+package net.minecraft.client.gui.modelviewer.categories.entries.entity;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.GuiButton;
+import net.minecraft.client.gui.GuiScreen;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.world.World;
+
+import java.util.List;
+
+public class BlankEntry extends EntityEntry<Entity> {
+    @Override
+    public void onTick(Entity entity) {
+
+    }
+
+    @Override
+    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, Entity entity) {
+        return null;
+    }
+
+    @Override
+    public Entity getEntityInstance(Minecraft mc, World world) {
+        return null;
+    }
+
+    @Override
+    public void onOpen() {
+
+    }
+
+    @Override
+    public void onClose() {
+
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/DispatcherEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/DispatcherEntry.java
new file mode 100644
index 000000000..1551922d5
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/DispatcherEntry.java
@@ -0,0 +1,41 @@
+package net.minecraft.client.gui.modelviewer.categories.entries.entity;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.GuiButton;
+import net.minecraft.client.gui.GuiScreen;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.EntityDispatcher;
+import net.minecraft.core.world.World;
+
+import java.util.List;
+
+public class DispatcherEntry extends EntityEntry<Entity> {
+    public final String id;
+    public DispatcherEntry(String dispatcherId){
+        id = dispatcherId;
+    }
+    @Override
+    public void onTick(Entity entity) {
+
+    }
+
+    @Override
+    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, Entity entity) {
+        return null;
+    }
+
+    @Override
+    public Entity getEntityInstance(Minecraft mc, World world) {
+        return EntityDispatcher.createEntityInWorld(id, Minecraft.getMinecraft(this).theWorld);
+    }
+
+    @Override
+    public void onOpen() {
+
+    }
+
+    @Override
+    public void onClose() {
+
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityArmoredZombieEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityArmoredZombieEntry.java
new file mode 100644
index 000000000..b8339e7a1
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityArmoredZombieEntry.java
@@ -0,0 +1,49 @@
+package net.minecraft.client.gui.modelviewer.categories.entries.entity;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.GuiButton;
+import net.minecraft.client.gui.GuiScreen;
+import net.minecraft.client.gui.modelviewer.elements.GuiListenerButton;
+import net.minecraft.core.entity.monster.EntityArmoredZombie;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.world.World;
+
+import java.util.ArrayList;
+import java.util.List;
+
+public class EntityArmoredZombieEntry extends EntityEntry<EntityArmoredZombie>{
+    @Override
+    public void onTick(EntityArmoredZombie entity) {
+
+    }
+
+    @Override
+    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, EntityArmoredZombie armoredZombie) {
+        List<GuiButton> buttonList = new ArrayList<>();
+        GuiListenerButton swordButton = new GuiListenerButton(-1, - 120, 0, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.armored_zombie.button.sword", false));
+        swordButton.setActionListener(() -> {
+            boolean hasSword1 = armoredZombie.getHeldItem() != null;
+            armoredZombie.setHoldingSword(!hasSword1);
+            swordButton.displayString = I18n.getInstance().translateKeyAndFormat("model.category.entity.armored_zombie.button.sword", hasSword1);
+        });
+        buttonList.add(swordButton);
+        return buttonList;
+    }
+
+    @Override
+    public EntityArmoredZombie getEntityInstance(Minecraft mc, World world) {
+        EntityArmoredZombie armoredZombie = new EntityArmoredZombie(world);
+        armoredZombie.setHoldingSword(false);
+        return armoredZombie;
+    }
+
+    @Override
+    public void onOpen() {
+
+    }
+
+    @Override
+    public void onClose() {
+
+    }
+}
